/*
 * jquery.smartsticky
 * Copyright (c) 2019 Ebrahim Fallah
 * version 1.0
 */
$.fn.sticky = function (options) {
    var el = $(this);
    var down = $(options.stopOn);
    var start_location = (el.offset().top - options.top);
    var enable = true;
    $(window).resize(function () {
        if ($(window).width() <= options.disableOn) {
            enable = false;
            el.css({
                'position': '',
                'width': '',
                'top': '',
                'bottom': ''
            });
            el.parent().css('position', '');
        } else {
            enable = true;
            el.parent().css('position', 'relative');
        }
    }).resize();
    $(window).scroll(function () {
        if (enable) {
            var scrollTop = $(window).scrollTop();
            var isDown = down.offset().top <= (scrollTop + options.top + el.height() + options.bottom);
            if (scrollTop >= start_location && !isDown) {
                el.css({
                    'position': 'fixed',
                    'width': el.width() + 'px',
                    'top': options.top + 'px',
                    'bottom': ''
                });
            }
            else if (scrollTop < start_location) {
                el.css({
                    'position': '',
                    'width': '',
                    'top': ''
                });
            }
            if (scrollTop >= start_location && isDown) {
                el.css({
                    'position': 'absolute',
                    'top': '',
                    'bottom': options.bottom + 'px'
                });
            }
        }
    });
};